/******************************************************************************\
*                                  JZip                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   (C) Copyright 1999-2000 Cramon Utilities and Bytamin-C                     *
*                                                                              *
* WWW:                                                                         *
*   http://www.bytamin-c.com                                                   *
*                                                                              *
* DISCLAMER:                                                                   *
*   THE AUTHOR(S) MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY *
*   OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO   *
*   THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR        *
*   PURPOSE, OR NON-INFRINGEMENT. THE AUTHOR(S) SHALL NOT BE LIABLE FOR ANY    *
*   DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR            *
*   DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.                             *
*                                                                              *
* ---------------------------------------------------------------------------- *
* Last changed      Name                   Changes                             *
* 01/13-2000        Jeppe Cramon           Prepared for OpenSource release     *
\******************************************************************************/

//---------------------------------------------------------------------------
#ifndef AddUnitH
#define AddUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "SystemComboBox.hpp"
#include "SystemControlPack.hpp"
#include "SystemListView.hpp"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TAddForm : public TForm
{
__published:	// IDE-managed Components
    TdfsSystemListView *SystemListView;
    TdfsSystemComboBox *SystemComboBox;
    TLabel *Label1;
    TLabel *Label2;
    TEdit *NameEdit;
    TBitBtn *AddBitBtn;
    TBitBtn *CancelBitBtn;
    TTimer *Timer1;
    TGroupBox *GroupBox1;
    TLabel *Label3;
    TComboBox *ActionComboBox;
    TBitBtn *PasswordBitBtn;
    TLabel *Label4;
    TComboBox *CompressionComboBox;
    TGroupBox *GroupBox2;
    TCheckBox *SubFldrCheckBox;
    TCheckBox *ExtraFldrCheckBox;
    TGroupBox *GroupBox3;
    TCheckBox *SysFilesCheckBox;
    TCheckBox *ForceDOSCheckBox;
    TBitBtn *AddWtihWBitBtn;
    TSpeedButton *ListSpeedButton;
    TSpeedButton *DetailsSpeedButton;
    TSpeedButton *UpBitBtn;
    void __fastcall UpBitBtnClick(TObject *Sender);


    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall SystemComboBoxChange(TObject *Sender);

    void __fastcall ListSpeedButtonClick(TObject *Sender);
    void __fastcall DetailsSpeedButtonClick(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall NameEditChange(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall PasswordBitBtnClick(TObject *Sender);
    void __fastcall SystemListViewPopulated(TObject *Sender);


    void __fastcall FormDestroy(TObject *Sender);

    void __fastcall SystemListViewKeyPress(TObject *Sender, char &Key);
private:	// User declarations
    bool    bDoubleClick;
public:		// User declarations
    __fastcall TAddForm(TComponent* Owner);
    AnsiString DefaultWildCard;
    AnsiString Password;
    AnsiString RootDir;

    bool __fastcall IsDirectory(AnsiString Dir);
};
//---------------------------------------------------------------------------
extern PACKAGE TAddForm *AddForm;
//---------------------------------------------------------------------------
#endif
