/******************************************************************************\
*                                  JZip                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   (C) Copyright 1999-2000 Cramon Utilities and Bytamin-C                     *
*                                                                              *
* WWW:                                                                         *
*   http://www.bytamin-c.com                                                   *
*                                                                              *
* DISCLAMER:                                                                   *
*   THE AUTHOR(S) MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY *
*   OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO   *
*   THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR        *
*   PURPOSE, OR NON-INFRINGEMENT. THE AUTHOR(S) SHALL NOT BE LIABLE FOR ANY    *
*   DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR            *
*   DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.                             *
*                                                                              *
* ---------------------------------------------------------------------------- *
* Last changed      Name                   Changes                             *
* 01/13-2000        Jeppe Cramon           Prepared for OpenSource release     *
\******************************************************************************/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CommentUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCommentForm *CommentForm;
//---------------------------------------------------------------------------
__fastcall TCommentForm::TCommentForm(TComponent* Owner)
    : TForm(Owner)
{
    Comment = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TCommentForm::ClearBitBtnClick(TObject *Sender)
{
    Memo->Lines->Clear();
    ClearBitBtn->Enabled = false;
    SaveBitBtn->Enabled = true;
    Memo->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TCommentForm::MemoChange(TObject *Sender)
{
    if (Memo->Lines->Text == "")
        ClearBitBtn->Enabled = false;
    else
        ClearBitBtn->Enabled = true;

    SaveBitBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TCommentForm::FormDestroy(TObject *Sender)
{
    Comment->Clear();
    delete Comment;
}
//---------------------------------------------------------------------------
void __fastcall TCommentForm::SaveBitBtnClick(TObject *Sender)
{
    Comment->Clear();
    Comment->Assign(Memo->Lines);
    SaveBitBtn->Enabled = false;
    bSave = true;
    Memo->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TCommentForm::FormShow(TObject *Sender)
{
    SaveBitBtn->Enabled = false;
    bSave = false;
}
//---------------------------------------------------------------------------

