/******************************************************************************\
*                                  JZip                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   (C) Copyright 1999-2000 Cramon Utilities and Bytamin-C                     *
*                                                                              *
* WWW:                                                                         *
*   http://www.bytamin-c.com                                                   *
*                                                                              *
* DISCLAMER:                                                                   *
*   THE AUTHOR(S) MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY *
*   OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO   *
*   THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR        *
*   PURPOSE, OR NON-INFRINGEMENT. THE AUTHOR(S) SHALL NOT BE LIABLE FOR ANY    *
*   DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR            *
*   DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.                             *
*                                                                              *
* ---------------------------------------------------------------------------- *
* Last changed      Name                   Changes                             *
* 01/13-2000        Jeppe Cramon           Prepared for OpenSource release     *
\******************************************************************************/

//---------------------------------------------------------------------------
#ifndef MainUnitH
#define MainUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "ZipBuilder.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include "Placemnt.hpp"
#include <Menus.hpp>
#include <Grids.hpp>
#include <Dialogs.hpp>
#include "EnhListView.hpp"
#include "ExtListView.hpp"
#include "SystemImageList.hpp"
#include "DropSource.hpp"
#include "DropTarget.hpp"
#include "dfsStatusBar.hpp"
#include <ImgList.hpp>
//---------------------------------------------------------------------------
const int iDesktop = 0;
const int iStartMenu = 1;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TImageList *NormalImageList;
    TToolBar *ToolBar;
    TToolButton *NewToolButton;
    TToolButton *OpenToolButton;
    TToolButton *ToolButton3;
    TToolButton *AddToolButton;
    TToolButton *ExtractToolButton;
    TToolButton *ToolButton6;
    TToolButton *ViewToolButton;
    TToolButton *InstallToolButton;
    TFormPlacement *FormPlacement1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TImageList *DisabledImageList;
    TZipBuilder *ZipBuilder;
    TMenuItem *NewArchive1;
    TMenuItem *OpenArchive1;
    TMenuItem *CloseArchive1;
    TMenuItem *N1;
    TMenuItem *CreateShortcut1;
    TMenuItem *N2;
    TMenuItem *MoveArchive1;
    TMenuItem *CopyArchive1;
    TMenuItem *RenameArchive1;
    TMenuItem *DeleteArchive1;
    TMenuItem *N3;
    TMenuItem *Exit1;
    TMenuItem *Actions1;
    TMenuItem *Add1;
    TMenuItem *Delete1;
    TMenuItem *Extract1;
    TMenuItem *View1;
    TMenuItem *N4;
    TMenuItem *SelectAll1;
    TMenuItem *N5;
    TMenuItem *InvertSelection1;
    TMenuItem *MakeEXEFile1;
    TMenuItem *Test1;
    TMenuItem *Comment1;
    TMenuItem *Checkout1;
    TMenuItem *Install1;
    TMenuItem *Options1;
    TMenuItem *Configuration1;
    TMenuItem *Password1;
    TMenuItem *N6;
    TMenuItem *Sort1;
    TMenuItem *byName1;
    TMenuItem *by1;
    TMenuItem *bySize1;
    TMenuItem *byPacked1;
    TMenuItem *byPath1;
    TOpenDialog *OpenDialog;
    TMenuItem *Help1;
    TMenuItem *About1;
    TOpenDialog *NewDialog;
    TdfsExtListView *ExtListView;
    TMenuItem *TodoList1;
    TMenuItem *N7;
    TMenuItem *LicenseAgreement1;
    TdfsSystemImageList *SysImgList;
    TPopupMenu *PopupMenu;
    TMenuItem *OpenFile1;
    TMenuItem *Add2;
    TMenuItem *Delete2;
    TMenuItem *Extract2;
    TMenuItem *View2;
    TMenuItem *N8;
    TMenuItem *SelectAll2;
    TMenuItem *InvertSelection2;
    TMenuItem *N9;
    TMenuItem *MakeEXEFile2;
    TMenuItem *Test2;
    TMenuItem *Comment2;
    TMenuItem *Install2;
    TMenuItem *CheckOut2;
    TToolButton *AboutToolButton;
    TToolButton *ToolButton2;
    TDropFileTarget *DropFileTarget;
    TDropFileSource *DropFileSource;
    TdfsStatusBar *StatusBar;
    void __fastcall OpenArchive1Click(TObject *Sender);
    void __fastcall OpenToolButtonClick(TObject *Sender);


    void __fastcall NewArchive1Click(TObject *Sender);
    void __fastcall NewToolButtonClick(TObject *Sender);
    void __fastcall Add1Click(TObject *Sender);
    void __fastcall AddToolButtonClick(TObject *Sender);

    void __fastcall ExtListViewChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
    void __fastcall SelectAll1Click(TObject *Sender);
    void __fastcall InvertSelection1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);

    void __fastcall ZipBuilderProgress(TObject *Sender,
          ProgressType ProgrType, AnsiString FileName, long FileSize);
    void __fastcall Extract1Click(TObject *Sender);
    void __fastcall ExtractToolButtonClick(TObject *Sender);

    void __fastcall ExtListViewMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall ExtListViewDblClick(TObject *Sender);
    void __fastcall Install1Click(TObject *Sender);
    void __fastcall InstallToolButtonClick(TObject *Sender);
    void __fastcall View1Click(TObject *Sender);
    void __fastcall ViewToolButtonClick(TObject *Sender);
    void __fastcall CloseArchive1Click(TObject *Sender);


    void __fastcall Comment1Click(TObject *Sender);
    void __fastcall Test1Click(TObject *Sender);
    void __fastcall ZipBuilderMessage(TObject *Sender, int ErrCode,
          AnsiString Message);
    void __fastcall About1Click(TObject *Sender);
    void __fastcall Delete1Click(TObject *Sender);
    void __fastcall MakeEXEFile1Click(TObject *Sender);
    void __fastcall LicenseAgreement1Click(TObject *Sender);

    void __fastcall OpenFile1Click(TObject *Sender);
    void __fastcall Add2Click(TObject *Sender);
    void __fastcall Delete2Click(TObject *Sender);
    void __fastcall Extract2Click(TObject *Sender);
    void __fastcall View2Click(TObject *Sender);
    void __fastcall SelectAll2Click(TObject *Sender);
    void __fastcall InvertSelection2Click(TObject *Sender);
    void __fastcall MakeEXEFile2Click(TObject *Sender);
    void __fastcall Test2Click(TObject *Sender);
    void __fastcall Comment2Click(TObject *Sender);
    void __fastcall Install2Click(TObject *Sender);
    void __fastcall AboutToolButtonClick(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall ExtListViewMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall DropFileSourceDrop(TObject *Sender, TDragType DragType,
          bool &ContinueDrop);

    void __fastcall Password1Click(TObject *Sender);
    void __fastcall ZipBuilderPasswordError(TObject *Sender,
          AnsiString &NewPassword, AnsiString ForFile,
          unsigned &RepeatCount);
    void __fastcall FormResize(TObject *Sender);

    void __fastcall Configuration1Click(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);

    void __fastcall ZipBuilderExtractOverwrite(TObject *Sender,
          AnsiString ForFile, bool IsOlder, bool &DoOverwrite);
    void __fastcall DropFileTargetDrop(TObject *Sender,
          TShiftState ShiftState, TPoint &Point, int &Effect);
    void __fastcall TodoList1Click(TObject *Sender);
private:	// User declarations
    void __fastcall Update();
    AnsiString __fastcall CreateTempDir();
    void __fastcall DeleteDir(AnsiString Dir);
    void __fastcall CreateShortCut(const AnsiString &file, int iDestination);
    void __fastcall DeleteShortCut(int iDestination);
    void __fastcall ReadConfiguration();
    void __fastcall SetConfiguration();
    void __fastcall WriteConfiguration();

    long TotalBytes;         // Total bytes in the zip file
    long TotalSelected;      // Total bytes selected
    AnsiString StartupDirectory;
    bool    bExtractSelected;   // Workaround for bug in TZipBuilder
    bool    bTesting;           // testing the archive?
    int     iTestErrors;
    bool    bInProgress;        // Test flag for abort routine
    bool    bYesToAll;          // Yes to All selected during overwrite

    int iMouseX, iMouseY;
    AnsiString InstallProgram;
    TStringList* CleanUpList;    // List that contains files that needs to be cleanedup

    // Drag/drop
    bool bDragging;
    bool bDraggingOverUs;

    /* --- Settings --- */
    // View
    bool bFullRowSelect;
    bool bGridLines;
    bool bFlatScroolBars;

    bool bUseCurrentFolderSettings;
    bool bSingleClick;
    int  iSingleClickOption;
    bool bDoubleClick;

    // Toolbar
    bool bShowButtonText;
    bool bShowToolTip;
    bool bFlatButtons;

    // System
    bool bAssociateWithZIP;
    bool bIncludeInStartMenu;
    bool bIncludeOnDesktop;
public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    __fastcall ~TMainForm();

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
